*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* chat.s
*
* v0.3 21/01/03
*
* implements CHAT (see man chat)
*

DEFINE @Question	1GETLAM
DEFINE !Question	1PUTLAM
DEFINE @Received	2GETLAM
DEFINE !Received	2PUTLAM
DEFINE @Size		3GETLAM
DEFINE !Size		3PUTLAM
DEFINE @DispX		4GETLAM
DEFINE !DispX		4PUTLAM
DEFINE PENULTLINE	FIFTYTHREE
DEFINE LASTLINE		FIFTYNINE
DEFINE VLASTLINE	SIXTYTHREE
DEFINE VLASTLINE2	SIXTYFOUR
DEFINE VLASTCOL		BINT_130d
DEFINE VLASTCOL2	BINT_131d
DEFINE MAXCHARS+1	SIXTYTWO

ASSEMBLE
	CON(1)	8
RPL
xNAME CHAT
:: CK1&Dispatch list
  ::
NULLNAME chat
::
 SerialInit
 DUPNULL{}? IT :: DROP RDROP ;	( if { }, don't do anything more ! )
 ZEROZERO NULL$ DUP
 { NULLLAM NULLLAM NULLLAM NULLLAM } BIND

 _b_fl_Verbose TestUserFlag IT
 ::
  RECLAIMDISP			( clears text but XXX : makes it 131x56 )
  TURNMENUOFF				( this makes text 131x64 )
 ;
 INNERCOMP
 reversym
 ::
  #1+_ONE_DO (DO)
   ::
    :: DUPTYPECSTR? IT :: DUPNULL$? ?SKIP RDROP ; DROPRDROP ;	( if not string or no question, no wait )
 
    _b_fl_Verbose TestUserFlag IT
    ::
 ( Displays the question )
     LASTLINE FIVE BLANKIT		( clears 5 lines from LASTLINE )
     DUP MAXCHARS+1 1_#1-SUB$ $>grob
     ZEROZERO VLASTCOL2 FIVE SUBGROB HARDBUFF ZERO LASTLINE GROB!
    ;
    DUPLEN$
    !Size !Question
    @Received CHR_Space >H$
    BEGIN
     ATTN? IT :: ATTNFLGCLR FLUSHKEYS ABORT ;
     DUP @Question ONE POS$
     DUP#0=ITE
      DROPTRUE
     ::
      @Size #+ LAST$ FALSE	( found it => delete it )
     ;
    WHILE
     DUPLEN$ @Size #<ITE
     ::
 ( too narrow to be the question, let's read more ! )
      UARTBUFLEN #0= IT
      ::
       ERROR@ JstGETTHEMSG DISPROW6
      ;
      GETSERIAL DROP
 
      _b_fl_Verbose TestUserFlag IT
      ::
 ( got something... let's show it, with scrolling screen )
       DUP
       BEGIN
        DUP CHR ^J ONE POSCHR #0<>
       WHILE
 
 ( this is SEP$NL, unsupported on hp39/40 :( )
 ASSEMBLE
 	IFDEF	__HP3X__
 RPL
        DUP CHR_Newline ONE POS$
        DUP#0= IT
        :: DROPDUP LEN$ #1+ ;
        2DUP #1- ONESWAP SUB$
        UNROT #1+ OVER LEN$
        SUB$SWAP
 ASSEMBLE
 	ELSE
 RPL
        SEP$NL						( picks one line )
 ASSEMBLE
 	ENDIF
 RPL
 
        VLASTCOL @DispX #<				( still within screen ?)
        ITE_DROP
        ::
         MAXCHARS+1 1_#1-SUB$ $>grob ZEROZERO VLASTCOL2 @DispX #- FIVE SUBGROB
         HARDBUFF @DispX PENULTLINE GROB!
        ;
        HARDBUFF ZERO SIX VLASTCOL2 LASTLINE SUBGROB
        HARDBUFF ZEROZERO GROB!			( and scroll screen )
        HARDBUFF ZERO PENULTLINE VLASTCOL2 LASTLINE GROB!ZERODRP
        ZERO !DispX
       REPEAT
       VLASTCOL @DispX #<
       ITE_DROP
       ::
        MAXCHARS+1 1_#1-SUB$ $>grob ZEROZERO VLASTCOL2 @DispX #- FIVE SUBGROB
        DUP GROBDIMw SWAP
        HARDBUFF @DispX PENULTLINE GROB!
        @DispX #+ !DispX
       ;
      ;
 ( and add it )
      &$
     ;
 
     ::
 ( too big, let's shrink it )
      DUPLEN$ @Size #- #2+ LAST$
     ;
 
    REPEAT
    !Received
   ;
   INDEX@ #1+ DUP INDEXSTO ISTOP@ #<
   IT
   ::
    _b_fl_Verbose TestUserFlag IT
    ::
     LASTLINE FIVE BLANKIT		( clears 5 lines from LASTLINE )
     DUP MAXCHARS+1 1_#1-SUB$ $>grob
     ZEROZERO VLASTCOL2 FIVE SUBGROB HARDBUFF ZERO LASTLINE GROB!
    ;
    PUTSERIAL				( tell the answer )
    ?SKIP
    :: 3RDROP FALSE ;			( goes out from the loop )
   ;
  LOOP
  TRUE					( normal return value )
 ;
 _b_fl_Verbose TestUserFlag IT
(  SetDAsTemp				( freeze all display areas )
ASSEMBLE
	IFDEF	__HP4X__
RPL
  ClrDAsOK				( redraw screen )
ASSEMBLE
	ELSE
RPL
  SetDAsBad
ASSEMBLE
	ENDIF
RPL
 ABND
;
    ?SEMI ERRORSTO ERRJMP
  ;
;
