*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* serial.s
*
* v0.3 07/07/03
*
* serial port handling
*

ASSEMBLE
	INCLUDE include/serial.a
	INCLUDE serial/send.a
	INCLUDE serial/rec.a
RPL

NULLNAME SerialInit

ASSEMBLE
hp4x	IFDEF	__HP4X__
RPL
::
 GetIOPAR
 2SWAP 2DROP %1 %0 2SWAP	( set XON/XOFF sending, but not receiving )
 SIX {}N
 StoIOPAR

ASSEMBLE
	#IF	INTERRUPT_HANDLER
RPL
 CODE
	GOSBVL	=SAVPTR
	GOSUB	=hdlc_uninst
	GOSBVL	=GETPTRLOOP
 ENDCODE
ASSEMBLE
	#ENDIF
RPL

 DOOPENIO
 BEGIN				( flush buffer )
  UARTBUFLEN DROP
 DUP#0<>WHILE DOCOL (WHILE)
  GETSERIAL 2DROP
 REPEAT
 DROP
;

ASSEMBLE
hp4x	ELSE
RPL

::
 OpenIO
;
ASSEMBLE
hp4x	ENDIF
RPL

	INCLUDE serial/chat.s
