*
* Usinagaz for hp4x v0.3
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* Distributed under the terms of the BSD licence, see COPYING-BSD
*
* usinagaz.s
*
* v0.3 15/09/02
*
* Internet for HP38/39/40/48/49
*

xROMID	6EC	( 1772 )

ASSEMBLE
=xxCONFIG
RPL

:: [#] ROMID# TOSRRP ;

	INCLUDE msgtab.s

* User RPL entries
EXTERNAL	xCHAT
EXTERNAL	xPPPON
EXTERNAL	xPPPOFF
EXTERNAL	xUIDLE
EXTERNAL	xUSOCKET
EXTERNAL	xUBIND
EXTERNAL	xUCONNECT
EXTERNAL	xUCLOSE
EXTERNAL	xUWRITE
EXTERNAL	xUREAD
EXTERNAL	xUACCEPT
EXTERNAL	xRESOLV
EXTERNAL	xUSOCK2MASK
EXTERNAL	xUSELECT
EXTERNAL	xUGETOPT
EXTERNAL	xUSETOPT

* Sys RPL entries
EXTERNAL	chat
EXTERNAL	pppon
EXTERNAL	pppoff
EXTERNAL	idle
EXTERNAL	socket
EXTERNAL	bind
EXTERNAL	connect
EXTERNAL	close
EXTERNAL	write
EXTERNAL	read
EXTERNAL	accept
EXTERNAL	resolv
EXTERNAL	sock2mask
EXTERNAL	select
EXTERNAL	getopt
EXTERNAL	setopt
EXTERNAL	USYS

* Assembly entry
EXTERNAL	UASM

* Internal use
EXTERNAL	Rclpar
EXTERNAL	SerialInit

ASSEMBLE
	INCLUDE		include/st.a
	INCLUDE		include/sizes.a
	INCLUDE		include/sav.a

	INCLUDE		include/mru.a
	INCLUDE		include/pap.a
	INCLUDE		include/ip.a
	INCLUDE		include/tcp.a
	INCLUDE		include/udp.a
	INCLUDE		lib/buffers.a
*
* Some various stuff
*
*********************

RPL
	INCLUDE		lib/sav.s


*
* Lower layers (RPL-accessible)
*
********************************

	INCLUDE		serial/serial.s
	INCLUDE		ppp/ppp.s
ASSEMBLE

*
* In-between layers (non RPL-accessible)
*
*****************************************

	INCLUDE		lib/cp.a
	INCLUDE		auth/auth.a
	INCLUDE		ip/ip.a
	INCLUDE		lib/timer.a
	INCLUDE		lib/tot_contr.a
	INCLUDE		udp/udp.a
	INCLUDE		tcp/tcp.a

*
* Upper layers (RPL-accessible)
*
********************************

RPL
	INCLUDE		socket/socket.s
	INCLUDE		resolv/resolv.s
	INCLUDE		socket/select.s

	INCLUDE		options.s

	INCLUDE		asm.s
	INCLUDE		sysrpl.s

