*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* sav.s
*
* v0.2 14/12/01
*
* Rclpar checks that the serial port is initialized, pushes the Library data
* Upar, creating it if needed.
* There are also routines to do pushs, errors, etc...
*

NULLNAME Rclpar
::
  FALSE
CODE
* picked up from Jazz (just like many things for lib creation)
	?C>B	A			PC > RPL return stack? (see DOCODE end)
	GOYES	+
	LA(5)	XErr_Covered
	GOVLNG	=Errjmp
+
	GOSBVL	=SAVPTR
	D0=(5)	=IOC
	A=DAT0	P
	?ABIT=0	3			wire serial port enable
	GOYES	+
	GOVLNG	=GETPTRLOOP
+
	GOSBVL	=GETPTR
	LC(5)	=TRUE
	DAT1=C	A			repl
	LOOP
ENDCODE
  IT SerialInit
ASSEMBLE
	IFDEF	__HP3X__
RPL
  LastBut3 CARCOMP			( Get Applet Upar )
ASSEMBLE
	ELSE
RPL
  ID Upar
ASSEMBLE
	ENDIF
RPL
  FALSE
CODE
	GOSBVL	=SAVPTR

* looks the beginning of Upar : Library data ?

	D1=D1+	SIZE_PTR
	A=DAT1	A
	D1=A
	A=DAT1	A
	LC(5)	=DOEXT0
	?A#C	A
	GOYES	+

* Checks the size

	D1=D1+	SIZE_PTR
	A=DAT1	A
	LC(5)	(=endbuffers)+(SIZE_PTR)
	?A#C	A
	GOYES	+

* looks a bit further to check in case it is a fake Upar (or an old version one)

	AD1EX
	LC(5)	(SIZE_PTR)+(sizeblank)+((config_packet)-(InitializedUpar))
	A=C+A	A
	D1=A
	A=DAT1	A
	C=A	A
	LC(4)	_LCP
	?A#C	A
	GOYES	+

	AD1EX
	LC(5)	((endbuffers)-(SIZE_PTR))-((sizeblank)+((config_packet)-(InitializedUpar)))
	A+C	A
	D1=A
	A=DAT1	A
	LC(5)	UparMagic
	?A#C	A
	GOYES	+

	GOVLNG	=GETPTRLOOP
+
	GOSBVL	=GETPTR
	LC(5)	=TRUE
	DAT1=C	A
	LOOP
ENDCODE
  IT
  ::
CODE
* get room for buffers and saves
	GOSBVL	=SAVPTR
	LC(5)	(=endbuffers)+2*(SIZE_PTR)
	GOSBVL	=GETTEMP	gets C nibbles -> @D0
	CD0EX	A
	R4=C.F	A
	CD1EX	A

* header
	LC(5)	=DOEXT0		library data
	DAT1=C	A
	D1+	SIZE_PTR

	LC(5)	(=endbuffers)+(SIZE_PTR)
	DAT1=C	A
	D1+	SIZE_PTR

* blank saves
	LC(5)	sizeblank
	GOSBVL	=WIPEOUT

* copy "ready to send" packets  (FIXME: must disappear !)
	A=PC	A
-
	LC(5)	(InitializedUpar)-(-)
	A=A+C	A
	D0=A				source in D0
	LC(5)	(endInitializedUpar)-(InitializedUpar)-1

	GOSBVL	=MOVEDOWN		COPY !

* reset default port (it's the best place !)
	A=R4.F	A
	LC(5)	(defaultport)+2*(SIZE_PTR)
	C=C+A	A
	D1=C

	LC(4)	(SOCK_fst_port)-1
	DAT1=C	SIZE_WORD

* and write Upar Magic
	LC(5)	((endbuffers)-(SIZE_PTR))+2*(SIZE_PTR)
	C+A	A
	D1=C
	LC(5)	UparMagic
	DAT1=C	A

*	A=R4.F	A			already there

	GOSBVL	=GETPTR

* replace the name by the content
	DAT1=A	A
	LOOP
ENDCODE
ASSEMBLE
	IFDEF	__HP3X__
RPL
    LastBut3 INNERDUP #2+ROLL OVER #2+ROLL DROP OVER #1+UNROLL {}N
    LastBut3 REPLACE DROP LastBut3 CARCOMP	( store & restore )
ASSEMBLE
	ELSE
RPL
    ' ID Upar SysSTO ID Upar
ASSEMBLE
	ENDIF
RPL
  ;
  _b_fl_Verbose TestUserFlag
  _b_fl_NBlock TestUserFlag
  _b_fl_Readln TestUserFlag
  _b_fl_Block TestUserFlag
;

* saveregs saves registers, ie ip addresses, etc...
* beware, Upar must be on level 1

ASSEMBLE
=saveregs
	LC(5)	=TRUE

	A=DAT1	A			Block mode ?
	ST=1	_b_st_Block
	?C=A	A
	GOYES	+
	ST=0	_b_st_Block
+
	D1+	SIZE_PTR		drop
	D+1	A

	A=DAT1	A			Read only one line ?
	ST=1	_b_st_Readln
	?C=A	A
	GOYES	+
	ST=0	_b_st_Readln
+
	D1+	SIZE_PTR		drop
	D+1	A

	A=DAT1	A			Non Block mode ?
	ST=1	_b_st_NBlock
	?C=A	A
	GOYES	+
	ST=0	_b_st_NBlock
+
	D1+	SIZE_PTR		drop
	D+1	A

	A=DAT1	A
	ST=1	_b_st_Verbose
	?C=A	A
	GOYES	+
	ST=0	_b_st_Verbose
+
	D1+	SIZE_PTR		drop
	D+1	A

	A=DAT1	A			address Upar
	A=A+CON	A,2*(SIZE_PTR)		points at the beginning of data
	R4=A.F	A
	D1+	SIZE_PTR		drop
	D+1	A

	GOSBVL	=SAVPTR

	GOTOL	=hdlc_install

=ckAis0
	?A#0	A
	GOYES	+
	RTNCC
+
-
	LC(5)	XErr_BadArgVal
	RTNSC

=ckDisPort
	LC(5)	_UDP_MaxPort
	?D>C	A
	GOYES	-
	RTNCC


*
* ckpppisconn checks IP is really connected
*
* modifies A & D1
*
=ckpppisconn
	A=R4.F	A
	D1=A
	D1+	(ipconnected)

	A=DAT1	P
	?A=0	P
	GOYES	+
	RTNCC
+
	LC(5)	XErr_Disconn
	RTNSC

myGPPushCFLoop
	R0=C.F	A
	GOSBVL	=GETPTR
	GOSBVL	=PUSH#
	GOVLNG	=PushFLoop

myGPDropPushCFLoop
	R0=C.F	A
	GOSBVL	=GETPTR
	D1+	SIZE_PTR		DROP
	D+1	A
	GOSBVL	=SAVPTR
	GOSBVL	=PUSH#
	GOVLNG	=PushFLoop

myGPPushATLoop
	R0=A.F	A
	GOSBVL	=GETPTR
	GOSBVL	=PUSH#
	GOVLNG	=PushTLoop
RPL
