*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* main.s
*
* v0.2 01/01/02
*
* user commands for PPP connection
*

*
*
* Pppon negociates the connection
*
*
ASSEMBLE
	CON(1)	8
RPL
xNAME PPPON
:: CK0
  ::
NULLNAME pppon
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR

* check for login/password in stack
	C=DAT1	A
	?C=0	A
	GOYES	+

	D=C	A			save passwd @ in D
	D0=C
	A=DAT0	A
	LC(5)	=DOCSTR
	?C#A	A
	GOYES	+

	D1+	SIZE_PTR
	C=DAT1	A
	?C=0	A
	GOYES	+

	B=C	A			save login @ in B
	D0=C
	A=DAT0	A
	LC(5)	=DOCSTR
	?C#A	A
	GOYES	+

* ok, there are some, let's record them
	A=R4.F	A
	LC(5)	paplnlogin
	C+A	A
	D1=C

	C=B	A			first login, since @ held in B !!

	GOSUB	CopyString

	A=R4.F	A
	LC(5)	paplnpasswd
	C+A	A
	D1=C

	C=D	A

	GOSUB	CopyString

+
sendlcpreq
* in case the host's tty is locked.
	LA(2)	_XON
	GOSUBL	=sendchar

	A=R4.F	A
	D0=A

* IP layer is down
	D0+	ipconnected
	LC(1)	_IP_notconnected
	DAT0=C	P

* toss until next frame
	D0+	(pppstatus)-(ipconnected)
	LC(1)	HDLC_TOSSING
	DAT0=C	B

	#IF	INTERRUPT_HANDLER
* reset pointers
	D0+	(intpointer)-(pppstatus)
	C=0	A
	DAT0=C	A
	D0+	(ppppointer)-(intpointer)
	DAT0=C	A
	D0-	(ppppointer)-(pppstatus)
	#ENDIF

* sets asyncmap to ALL !
	D0+	(ppplcpasyncmap)-(pppstatus)
	LC(8)	#FFFFFFFF
	DAT0=C	SIZE_DWORD

* sets mtu to default
	D0+	(mtu)-(ppplcpasyncmap)
	LC(5)	_defmtu
	DAT0=C	A

* clears FCS error number
	D0=D0+	(fcserror)-(mtu)
	C=0	A
	DAT0=C	A

* automates at the very beginning
	D0=D0+	(pppstate)-(fcserror)
	LC(1)	_Establish
	DAT0=C	P

	D0=D0+	(lcpstate)-(pppstate)
	LC(1)	_Req_Sent
	DAT0=C	P

* sets timeouts counter
	D0=D0+	(cptimeout)-(lcpstate)
	LC(1)	_num_retries
	DAT0=C	P

* sets no pap by default
	D0+	(pap_en)-(cptimeout)
	C=0	B
	DAT0=C	B

* try to ask for two dns addresses
	LC(1)	2
	D0+	(remotenbdns)-(pap_en)
	DAT0=C	B

* find a magic number, ie look for entropy
	A=R4.F	A
	LC(5)	(sizeblank)+((magic_config_packet)-(InitializedUpar))
	C+A	A
	D0=(5)	=CRC
	A=DAT0	A
	ASL	A
	ASL	W
	ASL	W
	ASL	W
	D1=(5)	=TIMER1
	A=DAT1	SIZE_WORD		FIXME: is useless since in RAM I/O, should write and read it back somewhere int RAM !
	A=DAT0	SIZE_WORD

	D1=C
	DAT1=A	SIZE_DWORD		and write it in config packet

* so as to launch negociation
	GOSUBL	=lcpscr

* wait until negociation is done, or excessive timeouts happened
	GOSUBL	=ztick
-
	GOSUBL	=tick
	GONC	++
	GOSUB	=lcptimeout
	GOC	ppponerr
	GOSUBL	=ztick
++
	GOSUBL	=rechdlc
	GOC	ppponerr

	A=R4.F	A
	LC(5)	ipconnected
	C=C+A	A
	D0=C
	A=DAT0	P
	LC(1)	_IP_connected
	?A#C	P
	GOYES	-

	GOVLNG	=GPPushTLoop
ppponerr
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
	CON(1)	8
RPL
xNAME PPPOFF
:: CK0
  ::
NULLNAME pppoff
::
  Rclpar
CODE
	GOSUBL	=saveregs

* IP layer is now down
	A=R4.F	A
	LC(5)	ipconnected
	C+A	A
	D0=C
	LC(1)	_IP_notconnected
	DAT0=C	P

* PPP layer is terminating
	D0+	(pppstate)-(ipconnected)
	LC(1)	_Terminate
	DAT0=C	P			Terminating

* set timeouts counter
	D0+	(cptimeout)-(pppstate)
	LC(1)	_num_retries
	DAT0=C	P

* so as to launch termination
	LCSTR	/User req/
	R0=C
	LCSTR	/uest.   /
	R1=C
	LC(4)	_LCP
	GOSUB	=send_Term_Req

* wait until termination is now, or excessive timeouts happened
	GOSUBL	=ztick
-
	GOSUBL	=tick
	GONC	++
	A=R4.F	A
	LC(5)	cptimeout
	C+A	A
	D0=C
	C=DAT0	P
	?C#0	P
	GOYES	+

* excessive timeouts, let's give up.
	GOSUBL	=hdlc_uninst

	LC(5)	XErr_Time
pppofferr
	GOTOL	myGPPushCFLoop

+
	LCSTR	/User req/
	R0=C
	LCSTR	/uest.   /
	R1=C
	LC(4)	_LCP
	GOSUB	=send_Term_Req
	GOSUBL	=ztick
++
	GOSUBL	=rechdlc
	GOC	pppofferr

	A=R4.F	A
	LC(5)	pppstate
	C=C+A	A
	D0=C
	A=DAT0	P
	LC(1)	_Dead
	?A=C	P
	GOYES	+
	GOTO	-

+
	GOSUBL	=hdlc_uninst

	GOVLNG	=GPPushTLoop
ENDCODE
  CLOSEUART
;
    ?SEMI ERRORSTO ERRJMP
  ;
;


ASSEMBLE
* copies string @C to @D1, storing size in byte rather than in nibbles
:CopyString
	D0=C
	D0+	SIZE_PTR
	A=DAT0	A
	A-CON	A,SIZE_PTR

	LC(5)	len_loginpass
	?A>C	A
	GOYES	toolong
	?A=0	A
	RTNYES				too short

	C=A	A
	ASRB.F	A
	DAT1=A	A

	D0+	SIZE_PTR
	D1+	SIZE_PTR
	GOVLNG	=MOVEDOWN

toolong
	LC(5)	XErr_MTU
	GOTOL	myGPPushCFLoop
RPL
