*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* bind.s
*
* v0.21 01/08/02
*
* sets a socket's local port :
* expects socket number and port number (hxs)
* gives same socket number
*

ASSEMBLE
	CON(1)		8
RPL
xNAME UBIND
:: CK2&Dispatch #1FB
  ::
ASSEMBLE
	IFDEF	__HP4X__
RPL
    HXS>#
ASSEMBLE
	ELSE
RPL
    CODE
    GOTOL	=myHXS>#
    ENDCODE
ASSEMBLE
	ENDIF
RPL

NULLNAME bind
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP2#				level 1 in C[A], 2 in A[A]
	RSTK=C					SAVPTR modifies C[A]
	GOSBVL	=SAVPTR
	C=RSTK
	D=C	A

	GOSUB	=Asm_BIND
	GOC	+

	GOTOL	myGPPushATLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;


ASSEMBLE
**
**
** Asm_UBIND
**
** In:  A[A] holds socket number (must be 0 for now, but please don't rely on it!
**      D[A] holds the port number to bind to
**
** Out: A[A] still holds the socket number
**      carry set on error, C[A] holds the error number
**
**
-
	LC(5)	XErr_AlConn
	RTNSC

=Asm_BIND
	GOSUBL	=ckAis0
	RTNC

* here's the port to bind
	GOSUBL	=ckDisPort
	RTNC

	A=R4.F	A
	LC(5)	socketconnected
	C+A	A
	D1=C

	C=DAT1	B
	?C#0	P
	GOYES	-

	D1-	(socketconnected)-(socketports)

	?D#0	A
	GOYES	++

* port 0 asked, ie next default available
	D1-	(socketports)-(defaultport)
	C=DAT1	A			only 4 used
	P=	(SIZE_WORD)-1
	C+1	WP
	P=	0
	GONC	+

* overflow, let's hope port SOCK_fst_port is still available...
	LC(4)	SOCK_fst_port

+
	DAT1=C	SIZE_WORD
	D1+	(socketports)-(defaultport)
	D=C	A
++
	C=D	B
	DSR	A			beware of endians !
	DSR	X
	CSL	X
	CSL	A
	C=D	B

	DAT1=C	SIZE_WORD

* clears received data
	D1+	(socketrcvd)-(socketports)
	A=0	W
	DAT1=A	2*(SIZE_PTR)

* and A is 0
	RTNCC
RPL
