*
* Usinagaz for hp4x
*  Copyright (C) 2000-2005 Samuel Thibault <samuel.thibault@ens-lyon.org>
*
* This program is free software ; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation ; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY ; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program ; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* accept.s
*
* v0.4 06/05/05
*
* selecting on connections
* (yeah ! hp48 being an ftp server ?!)
*
* takes 3 masks and the waiting time (>=#FFFFF for infinite)
* returns 3 masks.
*

ASSEMBLE
	CON(1)		8
RPL
xNAME USOCK2MASK
:: CK1&Dispatch
  #1F
NULLNAME sock2mask
  ::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR

	A=R4.F	A
	LC(5)	(sizeblank)+((hexstrMask)-(InitializedUpar))
	C+A	A
	RSTK=C

	GOSBVL	=POP#			socket number in A[A]

	GOSUB	=Asm_SOCK2MASK

	C=RSTK
	D0=C
	D0+	2*(SIZE_PTR)
	DAT0=A	W
	A=C	A
	GOSBVL	=GETPTR			A is not modified
	DAT1=A	A			REPL socket number by mask
	LOOP
ENDCODE
  ;
;

**
**
** Asm_SOCK2MASK
**
** In:  A[A] holds socket number
**
** Out: A[W] holds mask, carry is clear
**
**

ASSEMBLE
=Asm_SOCK2MASK
	C=A	B
	A=0	W
	LA(1)	1

	SB=0
	CSRB.F	B
	?SB=0				handle bit 0
	GOYES	+
	A+A	P
+
	SB=0
	CSRB.F	B
	?SB=0				handle bit 1
	GOYES	+
	A+A	P
	A+A	P
+
	?C=0	P
	GOYES	+
	C=-C-1	P
	P=C	0
-
	P+1				handle remaining bits
	GOC	+
	ASL	WP
	JUMP	-
+
	RTNCC
RPL

ASSEMBLE
	CON(1)		8
RPL
xNAME USELECT
:: CK4&Dispatch
  #BBB1 ::
    COERCE

NULLNAME select
::
  Rclpar
CODE
	GOSUBL	=saveregs
	GOSBVL	=GETPTR
	GOSBVL	=POP#			waiting time in A[A]
	GOSBVL	=SAVPTR

	GOSUB	=Asm_SELECT
	GOC	+

	GOVLNG	=GPPushTLoop
+
	GOTOL	myGPPushCFLoop
ENDCODE
;
    ?SEMI ERRORSTO ERRJMP
  ;
;

ASSEMBLE
**
**
** Asm_USELECT
**
** In:  
**
** Out: 
**      Carry set if an error occured, whose number will then be in C[A]
**
**


=Asm_SELECT
	RTNCC
RPL
